/*
 * SPDX-FileCopyrightText: 2019 Bruce Cowan <bruce@bcowan.me.uk>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <stdio.h>
#include <stdlib.h>

#include "utils.h"

static int list[] = { 8, 11, 17, 22, 29, 38, 51, 58, 65, 67, 74, 81, 87, 90, 96, 97 };

#define N_ELEMENTS(arr) (sizeof(arr) / sizeof(arr[0]))

static int
int_compare (const void *a, const void *b)
{
  static int passes;

  int first = *((int *) a);
  int second = *((int *) b);

  passes++;
  printf ("\n----------Pass #%d----------\n", passes);
  printf ("Comparing %d and %d\n", first, second);
  int ret = first - second;

  if (ret < 0)
    printf ("%d < %d\n", first, second);
  else if (ret > 0)
    printf ("%d > %d\n", first, second);
  else
    printf ("%d == %d\n", first, second);

  return ret;
}

int
main (int argc, char **argv)
{
  int *vals = get_ints (argc, argv, 1, "What is the number to search for?");
  int key = vals[0];

  bsearch (&key, list, N_ELEMENTS (list), sizeof (int), int_compare);

  return 0;
}
