/*
 * SPDX-FileCopyrightText: 2022-2023 Bruce Cowan <bruce@bcowan.me.uk>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <stdio.h>
#include <stdlib.h>

[[gnu::ifunc("resolve_func")]]
static void func (void);

static void
func_base (void)
{
    puts ("Base");
}

static void
func_avx2 (void)
{
    puts ("AVX2");
}

// declare resolve_func as static function (void) returning pointer to function (void) returning void
static void
(*resolve_func (void)) (void)
{
    __builtin_cpu_init ();

    if (__builtin_cpu_supports ("avx2"))
        return func_avx2;
    else
        return func_base;
}

int
main (void)
{
    func ();

    return 0;
}
